#include "MainServer.h"
#include <iostream>
#include <fstream>
#include <Zeit.h>
#include <Datei.h>
#include <Text.h>
#include <Globals.h>

int main()
{
    Framework::initFramework();
	Zeit *z = getZeit( );
	Text *pfad = new Text( "../log/main/" );
	pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
	z->release();
	DateiPfadErstellen( pfad->getThis( ) );
	std::ofstream file;
	file.open( pfad->getText( ) );
	std::streambuf* sbuf = std::cout.rdbuf( );
	std::cout.rdbuf( file.rdbuf( ) );
	pfad->release( );

	std::cout << "MS: Startet...\n";
	std::cout << "MS: Lese init Datei ../data/msInit.ini ...\n";

	InitDatei *dat = new InitDatei( "../data/msInit.ini" );
	if( !dat->laden() )
	{
		std::cout << "MS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit( 1 );
	}
    const char *wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv" };
    for( const char *w : wichtig )
    {
        if( !dat->wertExistiert( w ) )
        {
            std::cout << "MS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
            dat->release();
            exit( 1 );
        }
    }

	MainServer *mserver = new MainServer( dat );

	std::cout << "MS: Der Admin Server läuft. Startforgang beendet.\n";
	mserver->runn();

	mserver->ende();
	mserver->release();
	dat->release();
	std::cout << "MS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf( sbuf );
    Framework::releaseFramework();
	return 0;
}